// Minimal demo. It is hard to make a graphical program smaller.
// See minimalCG for a version that creates a CG context!
// Variation with a timer for animation.
// By Ingemar Ragnemalm 2008/2009

// C version. It doesn't work correctly, but since I have both
// a TransSkel5 and a plain Cocoa version, I don't think it is
// worth the trouble to fix a buggy Carbon/QuickDraw demo.

#include <Carbon/Carbon.h>

// uses option -fpascal-strings

	WindowRef	window;
	OSStatus	err;
	float loop = 0;

#define Pi 3.1415

static void DoThatStuff()
{
	Rect r;
	
//	r = *
	GetPortBounds(GetWindowPort(window), &r);
	EraseRect(&r);
	
	loop += 0.1;
	
	// Draw the spinning wheel
	MoveTo(100, 100);
	LineTo(200 + (100*sin(loop)), 200 + (100*cos(loop)));
	MoveTo(200 + (100*sin(loop)), 200 + (100*cos(loop)));
	LineTo(200 + (100*sin(loop+Pi)), 200 + (100*cos(loop+Pi)));
	MoveTo(200 + (100*sin(loop+Pi/2)), 200 + (100*cos(loop+Pi/2)));
	LineTo(200 + (100*sin(loop-Pi/2)), 200 + (100*cos(loop-Pi/2)));
	SetRect(&r, 100, 100, 300, 300);
	FrameOval(&r);
}

pascal void TimerAction(EventLoopTimerRef theTimer, void *userData)
//CALLBACK_API void TimerAction(EventLoopTimerRef inTimer, EventLoopIdleTimerMessage inState, void *inUserData)
{
	SetPortWindowPort(window);
	DoThatStuff();
//	printf("%d\n", (long)userData);
//	printf("%d\n", (long)inUserData);
//	printf("%d\n", (long)inState);
}

int main(int argc, char* argv[])
{
	Rect r;
	EventLoopTimerRef theTimer;
	
	SetRect(&r, 100, 100, 500, 500);
//	err = CreateNewWindow ( kDocumentWindowClass, kWindowStandardDocumentAttributes, &r, &window);
	window = NewWindow(NULL, &r, "\pHej", 0, documentProc, (WindowRef)-1, 0, 0 );
	SetWTitle(window, "\pMinimal");
	InstallStandardEventHandler(GetWindowEventTarget(window));
	ShowWindow(window);
	
	SetPortWindowPort(window);
	DoThatStuff();
	
	InstallEventLoopTimer (GetMainEventLoop(), 0.1*kEventDurationSecond, 0.02*kEventDurationSecond, // Asking for 50 fps
		TimerAction, (void *)43, &theTimer);
	
	// Call the event loop
	RunApplicationEventLoop();
	exit(0);
}
